import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;
import java.io.*;

public final class RMSTipos extends MIDlet implements CommandListener {
    private Display display;

	/**
	 * A nossa base de dados.
	 */
	/**/private RecordStore bd;/**/

	/**
	 * O formulrio para inserir novos registos.
	 */
	private Form formEntrada;

	/**
	 * Os campos do formulrio. Correspondem aos campos
	 * do registo na RecordStore.
	 */
	private TextField campoNome, campoNvel, campoPontuao;

	/**
	 * A lista com todas as entradas na base de dados.
	 */
	private List lista;

	/**
	 * Comandos para sair da aplicao, introduzir nova entrada, ver
	 * lista de entradas e para confirmar nova entrada.
	 */
	private Command cmdSair, cmdNova, cmdLista, cmdOk;

    public RMSTipos() {

		/* criar a caixa de entrada de texto	*/
		formEntrada = new Form("Nova entrada");

		campoNome = new TextField("Nome", "", 255, TextField.ANY);
		campoNvel = new TextField("Nvel", "", 2, TextField.NUMERIC);
		campoPontuao = new TextField("Pontuao", "", 5, TextField.NUMERIC);

		formEntrada.append(campoNome);
		formEntrada.append(campoNvel);
		formEntrada.append(campoPontuao);


		/* criar a lista que mostra todas as entradas	*/
		lista = new List("Entradas", List.IMPLICIT);


		/* criar os comandos e associ-los aos ecrs	*/
		cmdSair = new Command("Sair", Command.EXIT, 1);
		cmdNova = new Command("Nova", "Nova Entrada", Command.SCREEN, 2);
		cmdLista = new Command("Lista", "Lista Entradas", Command.SCREEN, 2);
		cmdOk = new Command("Ok", Command.OK, 0);

		formEntrada.addCommand(cmdOk);
		formEntrada.addCommand(cmdLista);
		formEntrada.setCommandListener(this);

		lista.addCommand(cmdSair);
		lista.addCommand(cmdNova);
		lista.setCommandListener(this);

    }

	/**
	 * Escreve um registo na RecordStore.
	 */
	/**/private void escreveRegisto(String nome, byte nvel, int pontuao) {
		try {
			ByteArrayOutputStream streamBytes = new ByteArrayOutputStream();

			DataOutputStream streamDados = new DataOutputStream(streamBytes);

			byte []registo;

			/* escrever os tipos primitivos					*/
			streamDados.writeUTF(nome);
			streamDados.writeByte(nvel);
			streamDados.writeInt(pontuao);

			streamDados.flush();

			/* obter o array para escrever na RecordStore	*/
			registo = streamBytes.toByteArray();

			System.out.println(new String(registo));

			bd.addRecord(registo, 0, registo.length);

			streamDados.close();
			streamBytes.close();
		} catch (IOException ioe) {
		} catch (RecordStoreException rse) {
		}
	}/**/


	/**
	 * Preenche a lista com todas as entradas encontradas na base de dados.
	 */
	private void preencheLista() {
		byte [] entrada = new byte[100];

		String nome;
		byte nvel;
		int pontuao;

		/**/ByteArrayInputStream streamBytes = new ByteArrayInputStream(entrada);
		DataInputStream streamDados = new DataInputStream(streamBytes);/**/

		/* limpar a lista porque vamos voltar a colocar todo o
			contedo da base de dados
		*/
		lista.deleteAll();

		try {
			for (int i = 1; i <= bd.getNumRecords(); i++) {

				/* ler o registo inteiro	*/
				/**/bd.getRecord(i, entrada, 0);/**/

				/* separar os campos		*/
				/**/nome = streamDados.readUTF();
				nvel = streamDados.readByte();
				pontuao = streamDados.readInt();/**/

				/* colocar entrada na lista	com todos os campos	*/
				lista.append(nome + " " + String.valueOf(nvel) + " " + String.valueOf(pontuao), null);

				/* reiniciar a stream 		*/
				/**/streamBytes.reset();/**/
			}
			/**/streamDados.close();
			streamBytes.close();/**/
		} catch (IOException ioe) {
			System.err.println("Erro de IO: " + ioe.getMessage());
		} catch (RecordStoreNotOpenException rsnoe) {
			System.err.println("A base de dados no foi aberta: " + rsnoe.getMessage());
		} catch (InvalidRecordIDException irie) {
			System.err.println("Identificador de registo invlido: " + irie.getMessage());
		} catch (RecordStoreException rse) {
			System.err.println("Erro ao aceder  base de dados: " + rse.getMessage());
		}
	}

    public void startApp() {
		/* vamos abrir (criar se ainda no tiver sido criada) a base de dados	*/
		try {
			bd = RecordStore.openRecordStore("ListaBD", true);
		} catch (RecordStoreException rse) {
			System.err.println("No foi possvel abrir a base de dados: " + rse.getMessage());
		}

		/* preencher a lista com as entradas */
		preencheLista();

		Display.getDisplay(this).setCurrent(lista);
    }

    public void pauseApp() {
		/* libertar o recurso */
		if (bd != null) {
			try {
				bd.closeRecordStore();
			} catch (RecordStoreNotOpenException rsnoe) {
			} catch (RecordStoreException rse) {
			}
		}
    }

    public void destroyApp(boolean unconditional) {
		/* libertar o recurso */
		if (bd != null) {
			try {
				bd.closeRecordStore();
			} catch (RecordStoreNotOpenException rsnoe) {
			} catch (RecordStoreException rse) {
			}
		}
    }

	public void commandAction(Command c, Displayable d) {
		if (c == cmdSair) {
			notifyDestroyed();

		} else if (c == cmdOk) {
			/* inserir entrada	*/
			String nome = campoNome.getString();
			byte nvel = Byte.parseByte(campoNvel.getString());
			int pontuao = Integer.parseInt(campoPontuao.getString());

			escreveRegisto(nome, nvel, pontuao);
			preencheLista();
			Display.getDisplay(this).setCurrent(lista);

		} else if (c == cmdLista) {
			preencheLista();
			Display.getDisplay(this).setCurrent(lista);

		} else if (c == cmdNova) {
			Display.getDisplay(this).setCurrent(formEntrada);
		}
	}
}